-- GLOBALS: _, TBResserPosition
local tonumber, GetSubZoneText, GetAreaSpiritHealerTime, SendAddonMessage, GetRealZoneText, ceil, tostring =
      tonumber, GetSubZoneText, GetAreaSpiritHealerTime, SendAddonMessage, GetRealZoneText, ceil, tostring

local babble = LibStub("LibBabble-SubZone-3.0"):GetLookupTable()
local zonebabble = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local addon = CreateFrame("Frame", "TBResser", UIParent)
addon:Hide()
hooksecurefunc("StaticPopup_Show", function(key)
	if key == "AREA_SPIRIT_HEAL" then
		local base
		local subtext = GetSubZoneText()
		if subtext == babble["Ironclad Garrison"] then
			base=1
		elseif subtext == babble["Slagworks"] then
			base=2
		elseif subtext == babble["Warden's Vigil"] then
			base=3
		end
		if base then
			SendAddonMessage("TBResser", base.."|"..GetAreaSpiritHealerTime(), "RAID")
		end
	end
end)
addon:SetScript("OnEvent", function(self, event, pre, msg)
	if event == "CHAT_MSG_ADDON" and pre == "TBResser" then
		local base, t = msg:match("(%d+)|(%d+)")
		base = tonumber(base)
		t = tonumber(t)
		if base and t then
			addon.timers[base] = t
			addon.updates[base]:Show()
			addon.est[base] = false
			if addon.bar.base == base then
				addon.bar:SetValue(t, false)
			end
		end
	elseif event == "ZONE_CHANGED" then
		if GetRealZoneText() ~= zonebabble["Tol Barad"] then
			addon:Hide()
			for i=1, 3 do
				addon.updates[i]:Hide()
				addon.timers[i] = nil
				addon.est[i] = nil
			end
			return
		end
		local z = GetSubZoneText()
		if z == babble["Ironclad Garrison"] then
			addon.bar:SetBase(1)
		elseif z == babble["Slagworks"] then
			addon.bar:SetBase(2)
		elseif z == babble["Warden's Vigil"] then
			addon.bar:SetBase(3)
		else
			addon.bar:SetBase(nil)
		end
	elseif event == "ADDON_LOADED" and pre == "TBResser" then
		TBResserPosition = TBResserPosition or {p="CENTER",r="CENTER",x=0,y=0}
		addon:SetPoint(TBResserPosition.p, nil, TBResserPosition.r, TBResserPosition.x, TBResserPosition.y)
		self:UnregisterEvent("ADDON_LOADED")
	end
end)
addon:SetSize(170, 35)
addon.tex = addon:CreateTexture()
addon.tex:SetAllPoints()
addon.tex:SetTexture(0.6,0.6,0.6)
addon.tex:SetAlpha(0.2)
addon.bar = CreateFrame("Frame", nil, addon)
addon.bar:SetSize(150, 15)
addon.bar:SetPoint("TOPLEFT", 10, -10)
addon.bar:SetPoint("BOTTOMRIGHT", -10, 10)
addon.bar.tex = addon.bar:CreateTexture(nil, "BACKGROUND")
addon.bar.tex:SetAllPoints()
addon.bar.tex:SetTexture(0.5,0.5,0.5)
addon.bar.tex:SetAlpha(0.8)
addon.bar.over = addon.bar:CreateTexture(nil, "ARTWORK")
addon.bar.over:SetPoint("TOPLEFT")
addon.bar.over:SetPoint("BOTTOMLEFT")
addon.bar.over:SetTexture(0.9,0.9,0.9)
addon.bar.over:SetAlpha(0.7)
addon.bar.text = addon.bar:CreateFontString(nil, "OVERLAY")
addon.bar.text:SetPoint("RIGHT", -5, 0)
addon.bar.text:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
addon.bar.text:SetTextColor(1,1,1)
addon.bar.label = addon.bar:CreateFontString(nil, "OVERLAY")
addon.bar.label:SetPoint("CENTER")
addon.bar.label:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
addon.bar.label:SetTextColor(1,1,1)
addon.bar.estimate = addon.bar:CreateFontString(nil, "OVERLAY")
addon.bar.estimate:SetPoint("LEFT", 5, 0)
addon.bar.estimate:SetFont("Fonts\\FRIZQT__.TTF", 12)
addon.bar.estimate:SetTextColor(0,0,0)
addon.bar.estimate:SetText("E")
function addon.bar:SetValue(i, e)
	if i < 30 then
		self.over:SetWidth((1-(i/30))*150)
		self.over:Show()
	else
		self.over:Hide()
	end
	i = ceil(i)
	if i ~= self.textcache then
		self.text:SetText(tostring(i))
	end
	if e ~= nil then
		self.estimate[e and "Show" or "Hide"](self.estimate)
	end
end
function addon.bar:SetBase(base)
	if base and addon.timers[base] then
		self:SetValue(addon.timers[base], addon.est[base])
		if base == 1 then
			self.label:SetText(babble["Ironclad Garrison"])
		elseif base == 2 then
			self.label:SetText(babble["Slagworks"])
		elseif base == 3 then
			self.label:SetText(babble["Warden's Vigil"])
		end
		addon:Show()
		self.base = base
	else
		addon:Hide()
		self.base = nil
	end
end
addon:RegisterEvent("CHAT_MSG_ADDON")
addon:RegisterEvent("ZONE_CHANGED")
addon:RegisterEvent("ADDON_LOADED")
RegisterAddonMessagePrefix("TBResser")
addon.updates = {}
addon.timers = {}
addon.est = {}
for i=1, 3 do
	local f = CreateFrame("Frame")
	f:Hide()
	f:SetScript("OnUpdate", function(self, elapsed)
		addon.timers[i]=addon.timers[i]-elapsed
		if addon.timers[i] < 0 then
			addon.timers[i] = addon.timers[i]+30
			addon.est[i] = true
			if addon.bar.base == i then
				addon.bar:SetValue(addon.timers[i], true)
			end
		else
			if addon.bar.base == i then
				addon.bar:SetValue(addon.timers[i])
			end
		end
	end)
	addon.updates[i] = f
end
addon:SetMovable(true)
addon:EnableMouse(true)
addon:SetScript("OnMouseDown", function(self)
	self:StartMoving()
end)
addon:SetScript("OnMouseUp", function(self)
	self:StopMovingOrSizing()
	local t=TBResserPosition
	t.p, _, t.r, t.x, t.y = self:GetPoint()
end)